/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Lib.xs. Do not edit this file, edit Lib.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Lib.xs"
#ifdef WIN32
#undef read
#undef write
#else
#include <sys/time.h>
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <event.h>
#include <assert.h>

/* shut up a compiler warning: ppport.h redefines
 * PERL_UNUSED_DECL already defined in perl.h */
#ifdef PERL_UNUSED_DECL
#   undef PERL_UNUSED_DECL
#endif

#include "ppport.h"

#include "const-c.inc"

#define CALLBACK_CAST	(void (*)(int, short, void*))
#define to_perlio(sv)	IoIFP(sv_2io(sv))
#define is_event(sv)	(SvTYPE(sv) == SVt_RV && sv_derived_from(sv, "Event::Lib::base"))

#define	EV_TRACE	    0x20

#define EVf_EVENT_SET	    0x00000001
#define EVf_PRIO_SET	    0x00000002
#define EVf_EVENT_DELETED   0x00000004
#define EVf_EVENT_TRACED    0x00000010	

#define EvFLAGS(ev)	    (ev->flags)

#define EvEVENT_SET(ev)		(EvFLAGS(ev) & EVf_EVENT_SET)
#define EvEVENT_SET_on(ev)	EvFLAGS(ev) |= EVf_EVENT_SET
#define EvEVENT_SET_off(ev)	EvFLAGS(ev) &= ~EVf_EVENT_SET

#define EvPRIO_SET(ev)		(EvFLAGS(ev) & EVf_PRIO_SET)
#define EvPRIO_SET_on(ev)	EvFLAGS(ev) |= EVf_PRIO_SET
#define EvPRIO_SET_off(ev)	EvFLAGS(ev) &= ~EVf_PRIO_SET

#define EvEVENT_TRACED(ev)	(EvFLAGS(ev) & EVf_EVENT_TRACED)
#define EvEVENT_TRACED_on(ev)	EvFLAGS(ev) |= EVf_EVENT_TRACED
#define EvEVENT_TRACED_off(ev)	EvFLAGS(ev) &= ~EVf_EVENT_TRACED

#define IN_GLOBAL_CLEANUP PL_dirty

SV * do_exception_handler (pTHX_ short event, SV *ev, SV *err);
void do_callback (int fd, short event, SV *ev);

struct event_args {
    struct event    ev;		/* the event that was triggered */
    SV		    *io;	/* the associated filehandle */
    CV		    *func;	/* the Perl callback to handle event */
    int		    num;	/* number of additional args */
    int		    buckets;	/* number of allocated slots for args (buckets >= args) */
    SV		    **args;	/* additional args */
    const char	    *type;	/* so we know into which class to bless in do_callback */
    CV		    *trapper;	/* exception handler */
    int		    evtype;	/* what kind of event or signal; always 0 for timer events */
    int		    priority;	/* what priority */
    int		    flags;	/* EVf_EVENT_SET, EVf_PRIO_SET */
#ifdef EVENT_LIB_DEBUG
    SV		    *loc;	/* location information: where was event created */
    char	    *cbname;	/* name of the callback */
#endif
};


CV *DEFAULT_EXCEPTION_HANDLER = NULL;

/* The following flag is set when we are inside a callback.  It is to prevent
 * incrementing of the reference-count of a an event when it is re-added from
 * inside its handler.  However, in order to allow something like that:
 *
 *  sub event_handler {
 *	my $ev = shift;
 *	...
 *	timer_new(...)->add(1);
 *  }
 *  
 * we additionally have to check if the currently executing event is to be
 * re-added (in this case: no refcnt++) or if another event was added (in this
 * case: refcnt++). 
 *
 * Therefore we have to store the address of the currently executing event in
 * IN_CALLBACK and a simply true/false flag wont do.
 *
 * If we don't do that, we get a refcount-to-infinity problem because
 * do_callback wont decrement the refcnt of an event when it's pending. And i
 * is certainly pending when it has been readded from within its handler.
 */
struct event_args *IN_CALLBACK = NULL;
#define ENTER_callback(ev)	IN_CALLBACK = ev
#define LEAVE_callback		IN_CALLBACK = NULL
#define RUNNING_callback(ev)	((ev) == IN_CALLBACK)

#include "event_debug.h"

void free_args (struct event_args *args) {
    
    register int i;

    if (args->io) {
	SvREFCNT_dec(args->io);
    }
   
    SvREFCNT_dec(args->func);
    for (i = 0; i < args->num; ++i)
	SvREFCNT_dec(args->args[i]);

    Safefree(args->args);

    if (args->trapper != DEFAULT_EXCEPTION_HANDLER)
	SvREFCNT_dec(args->trapper);

#ifdef EVENT_LIB_DEBUG
    SvREFCNT_dec(args->loc);
    Safefree(args->cbname);
#endif
    Safefree(args);
}

void refresh_event (struct event_args *args, char *class) {
    SV *sv = newSV(0);
    sv_setref_pv(sv, class, (void*)args);
    args->ev.ev_evcallback.evcb_arg = (void*)sv;
}

SV * do_exception_handler (pTHX_ short event, SV *ev, SV *err) {
    register int i;
    int count;
    struct event_args *args = (struct event_args*)SvIV(SvRV(ev));

    dSP;
    
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    
    EXTEND(SP, event ? args->num + 3 : 2);
    PUSHs(ev);
    
    PUSHs(sv_2mortal(err));

    if (event) {
	PUSHs(sv_2mortal(newSViv(event)));
	for (i = 0; i < args->num; i++)
	    PUSHs(args->args[i]);
    }
    

    PUTBACK;
    count = call_sv((SV*)args->trapper, G_SCALAR|G_EVAL);
    
    if (SvTRUE(ERRSV))
	croak(Nullch);
    
    SPAGAIN;
    
    if (count != 1)
	ev = &PL_sv_undef;
    else
	ev = POPs;
    
    PUTBACK;
    FREETMPS;
    LEAVE;

    return ev;
}

void do_callback (int fd, short event, SV *ev) {
    register int i;
    struct event_args *args = (struct event_args*)SvIV(SvRV(ev));
    dSP;

    DEBUG_trace(args);
    
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    
    EXTEND(SP, args->num + 2);

    PUSHs(ev);
    PUSHs(sv_2mortal(newSViv(event)));

    for (i = 0; i < args->num; ++i)
	PUSHs(args->args[i]);

    /* !!! START OF CALLBACK SECTION !!! */
    ENTER_callback(args);
    
    PUTBACK;
    call_sv((SV*)args->func, G_VOID|G_DISCARD|G_EVAL);
    if (SvTRUE(ERRSV))
	do_exception_handler(aTHX_ event, ev, newSVsv(ERRSV));
    
    LEAVE_callback;
    /* !!! END OF CALLBACK SECTION !!! */

    /* It's possible that the event was manually deleted inside the
     * handlers, in which case the ref-cnt has already been decremented */
    if (!event_pending(&args->ev, event, NULL)) {
	EvEVENT_SET_off(args);
    	SvREFCNT_dec((SV*)args->ev.ev_evcallback.evcb_arg);
	if (SvOK(ev))
	    DEBUG_trace(args);
    }

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}


#ifdef WIN32
#define THEINLINE __forceinline
#else
#define THEINLINE inline
#endif

THEINLINE void make_timeval (struct timeval *tv, double t) {
    tv->tv_sec = (long)t;
    tv->tv_usec = (t - (long)t) * 1e6f;
}

THEINLINE double delta_timeval (struct timeval *t1, struct timeval *t2) {
    double t1t = t1->tv_sec + (double)t1->tv_usec / 1e6f;
    double t2t = t2->tv_sec + (double)t2->tv_usec / 1e6f; 
    return t2t - t1t;
}

#ifdef HAVE_LOG_CALLBACKS
unsigned int LOG_LEVEL = _EVENT_LOG_ERR;
static const char* str[] = { "debug", "msg", "warn", "err", "???" };

void log_cb (int sev, const char *msg) {
    if (sev >= LOG_LEVEL) {
	if (sev > _EVENT_LOG_ERR) 
	    sev = _EVENT_LOG_ERR + 1;
	PerlIO_printf(PerlIO_stderr(), "[%s (pid=%i)] %s\n", str[sev], getpid() , msg);
    }
}
#endif

bool EVENT_LOOP_RUNNING = FALSE;
int  EVENT_INIT_DONE = -1;  /* we use the pid here */

#define event_do_init()	    \
{\
    int _pid_ = getpid(); \
    if (!EVENT_INIT_DONE  || EVENT_INIT_DONE != _pid_) {\
	event_init();	\
	DEBUG_init_pending(aTHX);   \
	DEBUG_init_count(aTHX);	    \
	EVENT_INIT_DONE = _pid_;    \
	IN_CALLBACK = 0;	    \
    }\
}

#line 278 "Lib.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 422 "Lib.c"

/* INCLUDE:  Including 'const-xs.inc' from 'Lib.xs' */


XS_EUPXS(XS_Event__Lib_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 447 "Lib.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Event::Lib macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Event::Lib macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Event::Lib macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 525 "Lib.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'Lib.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Event__Lib__default_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__default_callback)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 286 "Lib.xs"
{
    sv_setsv(ERRSV, ST(1));
    croak(Nullch);
    PERL_UNUSED_VAR(items); /* to silence the compiler */
}
#line 548 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib_event_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 296 "Lib.xs"
{
    event_do_init();
}
#line 565 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib_event_get_method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_get_method)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = event_get_method();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_event_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_get_version)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = event_get_version();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_event_log_level); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_log_level)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "level");
    {
	unsigned int	level = (unsigned int)SvUV(ST(0))
;
#line 314 "Lib.xs"
{
#ifdef HAVE_LOG_CALLBACKS
    LOG_LEVEL = level;
#endif
}
#line 622 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib_event_register_except_handler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_register_except_handler)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "func");
    {
	SV *	func = ST(0)
;
#line 324 "Lib.xs"
{
    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Argument to event_register_except_handler must be code-reference");
    DEFAULT_EXCEPTION_HANDLER = (CV*)SvRV(func);
}
#line 643 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib_event_priority_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_priority_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nump");
    {
	int	nump = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 335 "Lib.xs"
{
    event_do_init();
#ifdef HAVE_PRIORITIES
    RETVAL = event_priority_init(nump);
#else
    RETVAL = 1;
#endif
}
#line 669 "Lib.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_event_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_new)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "io, event, func, ...");
    {
	SV *	io = ST(0)
;
	short	event = (short)SvIV(ST(1))
;
	SV *	func = ST(2)
;
#line 352 "Lib.xs"
    static char *CLASS = "Event::Lib::event";
    struct event_args *args;
#line 692 "Lib.c"
	struct event_args *	RETVAL;
#line 355 "Lib.xs"
{
    register int i;

    if (GIMME_V == G_VOID)
	XSRETURN_UNDEF;

    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Third argument to event_new must be code-reference");

    event_do_init();

    New(0, args, 1, struct event_args); 

    args->io = io;
    args->func = (CV*)SvRV(func);
    args->type = CLASS;
    args->trapper = DEFAULT_EXCEPTION_HANDLER;
    args->evtype = event;
    args->priority = -1;

    EvFLAGS(args) = 0;

    DEBUG_store_location(aTHX_ args);
#ifdef EVENT_LIB_DEBUG
    /* is it a traced event? */
    if (event & EV_TRACE) {
	EvFLAGS(args) |= EVf_EVENT_TRACED;
	event &= ~EV_TRACE;
    }
#endif

    SvREFCNT_inc(args->io);
    SvREFCNT_inc(args->func);

    if ((args->buckets = args->num = items - 3)) 
	New(0, args->args, args->buckets, SV*);
    else
	args->args = NULL;

    for (i = 0; i < args->num; i++) {
	args->args[i] = ST(i+3);
	SvREFCNT_inc(args->args[i]);
    }

    RETVAL = args;
}
#line 741 "Lib.c"
#line 404 "Lib.xs"
    DEBUG_inc_count(EVENT_NEW_COUNT);
#line 744 "Lib.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
#line 406 "Lib.xs"
    DEBUG_record_allo(aTHX_ ST(0));
#line 753 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_signal_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_signal_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "signal, func, ...");
    {
	int	signal = (int)SvIV(ST(0))
;
	SV *	func = ST(1)
;
#line 413 "Lib.xs"
    static char *CLASS = "Event::Lib::signal";
    struct event_args *args;
#line 773 "Lib.c"
	struct event_args *	RETVAL;
#line 416 "Lib.xs"
{
    register int i;

    if (GIMME_V == G_VOID)
	XSRETURN_UNDEF;

    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Second argument to event_new must be code-reference");

    event_do_init();

    New(0, args, 1, struct event_args);

    args->io = NULL;
    args->func = (CV*)SvRV(func);
    args->type = CLASS;
    args->trapper = DEFAULT_EXCEPTION_HANDLER;
    args->evtype = signal;
    args->priority = -1;

    EvFLAGS(args) = 0;

    DEBUG_store_location(aTHX_ args);

    SvREFCNT_inc(args->func);

    if ((args->buckets = args->num = items - 2))
	New(0, args->args, args->buckets, SV*);
    else
	args->args = NULL;

    for (i = 0; i < args->num; i++) {
	args->args[i] = ST(i+2);
	SvREFCNT_inc(args->args[i]);
    }

    RETVAL = args;
}
#line 814 "Lib.c"
#line 457 "Lib.xs"
    DEBUG_inc_count(SIGNAL_NEW_COUNT);
#line 817 "Lib.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
#line 459 "Lib.xs"
    DEBUG_record_allo(aTHX_ ST(0));
#line 826 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_timer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_timer_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "func, ...");
    {
	SV *	func = ST(0)
;
#line 465 "Lib.xs"
    static char *CLASS = "Event::Lib::timer";
    struct event_args *args;
#line 844 "Lib.c"
	struct event_args *	RETVAL;
#line 468 "Lib.xs"
{
    register int i;

    if (GIMME_V == G_VOID)
	XSRETURN_UNDEF;

    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("First argument to timer_new must be code-reference");

    event_do_init();

    New(0, args, 1, struct event_args);

    args->io = NULL;
    args->func = (CV*)SvRV(func);
    args->type = CLASS;
    args->trapper = DEFAULT_EXCEPTION_HANDLER;
    args->evtype = 0;
    args->priority = -1;

    EvFLAGS(args) = 0;

    DEBUG_store_location(aTHX_ args);

    SvREFCNT_inc(args->func);

    if ((args->buckets = args->num = items - 1))
	New(0, args->args, args->buckets, SV*);
    else
	args->args = NULL;

    for (i = 0; i < args->num; i++) {
	    args->args[i] = ST(i+1);
	    SvREFCNT_inc(args->args[i]);
    }

    RETVAL = args;
}
#line 885 "Lib.c"
#line 509 "Lib.xs"
    DEBUG_inc_count(TIMER_NEW_COUNT);
#line 888 "Lib.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
#line 511 "Lib.xs"
    DEBUG_record_allo(aTHX_ ST(0));
#line 897 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_event_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "args, ...");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event_add() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 517 "Lib.xs"
{
#define FORMAT		"[event_add] ev = 0x%p (%s)\n  (from %s)\n  (by %s:%d)"

    struct timeval tv = { 1, 0 };
    int time_given = 0;
    int exception_flag = 0;

    DEBUG_trace(args);

    if (!EvEVENT_SET(args)) {
	DEBUG_warn(FORMAT, args, args->type, SvPV_nolen(args->loc),
		   CopFILE(PL_curcop) ? CopFILE(PL_curcop) : "unknown",
		   CopLINE(PL_curcop) ? CopLINE(PL_curcop) : -1);
	if (strEQ(args->type, "Event::Lib::event")) {
	    PerlIO *io = to_perlio(args->io);
	    int fd = io ? PerlIO_fileno(to_perlio(args->io)) : -1;
	    event_set(&args->ev, fd, (short)args->evtype, CALLBACK_CAST do_callback, (void*)ST(0));
	    if (fd == -1) {
		/* We always call event_set even when fd is potentially -1.
		 * This is only so that the exception handler is called with a
		 * proper event. However, we don't set the EvEVENT_SET flag so
		 * that this event will again be event_set()ed next time. */
		errno = EBADF;
		exception_flag = -args->evtype;
		goto force_failure;
	    }
	}
	else if (strEQ(args->type, "Event::Lib::signal")) {
	    signal_set(&args->ev, args->evtype, CALLBACK_CAST do_callback, (void*)ST(0));
	    exception_flag = -args->evtype;
	}
	else if (strEQ(args->type, "Event::Lib::timer")) {
	    evtimer_set(&args->ev, CALLBACK_CAST do_callback, (void*)ST(0));
	    exception_flag = -EV_TIMEOUT;
	}
	EvEVENT_SET_on(args);
	DEBUG_trace(args);
    } else if (event_pending(&args->ev, EV_TIMEOUT|EV_READ|EV_WRITE|EV_SIGNAL, NULL))
	croak("Attempt to add event a second time");
#ifdef HAVE_PRIORITIES
    if (!EvPRIO_SET(args)) {
	event_priority_set(&args->ev, args->priority);
	EvPRIO_SET_on(args);
    }
#endif

    if (sv_derived_from(ST(0), "Event::Lib::timer") && items == 1)
	time_given = 1;

    if (items > 1) {

	/* add(0) should behave like add() */
	if (SvIOK(ST(1)) && SvIV(ST(1)) == 0)
	    goto skip;

	make_timeval(&tv, SvNV(ST(1)));
	time_given = 1;
    }

    skip:
    if (event_add(&args->ev, time_given ? &tv : NULL) == 0) {

	/* Are we trying to re-add the currently executing event? */
	if (RUNNING_callback(args)) {
	    XSRETURN(1);
	}

	/* Nope, it's another event so it's ok to increment the ref-cnt */
	SvREFCNT_inc((SV*)args->ev.ev_evcallback.evcb_arg);
	DEBUG_record_event(aTHX_ ST(0));
	DEBUG_trace(args);
	XSRETURN(1);
    }

    force_failure:
    /* event_add failed :-( */
    do_exception_handler(aTHX_ exception_flag, ST(0), newSVpvn("Couldn't add event", 18));
}	
#line 998 "Lib.c"
#line 595 "Lib.xs"
#line 1000 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_event_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_free)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "args, flags = 0");
    {
	struct event_args *	args;
	int	flags;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event_free() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 602 "Lib.xs"
{
    if (!flags)
	warn("You should not call event_free unless it's an emergency");

    event_del(&args->ev);
    free_args(args);

    /* unbless referent:
     * this is crucial because access to the object after it
     * has been freed could lead to segfaults */
    SvFLAGS(SvRV(ST(0))) &= ~SVs_OBJECT;
}
#line 1043 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib_event_mainloop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_mainloop)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 619 "Lib.xs"
{
    int ret;
    if (EVENT_LOOP_RUNNING) {
	warn("Attempt to trigger another loop while the main-loop is already running");
	return;
    }

    EVENT_LOOP_RUNNING = TRUE;
    ret = event_dispatch();
    EVENT_LOOP_RUNNING = FALSE;
    if (ret == 1)
	XSRETURN_YES;
    else
	XSRETURN_NO;
}
#line 1072 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib_event_one_loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_one_loop)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 639 "Lib.xs"
{
    if (EVENT_LOOP_RUNNING) {
	warn("Attempt to trigger another loop while the main-loop is already running");
	return;
    }

    if (items > 0) {
	struct timeval tv;
	make_timeval(&tv, SvNV(ST(0)));
	event_loopexit(&tv);
    }
    event_loop(EVLOOP_ONCE);
}
#line 1099 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib_event_one_nbloop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib_event_one_nbloop)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 657 "Lib.xs"
{
    event_loop(EVLOOP_NONBLOCK);
}
#line 1116 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__base_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_remove)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::remove() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 667 "Lib.xs"
{
    /*******************************************************
     * !! THIS FUNCTION IS OVERRIDDEN FOR SIGNAL-EVENTS !! *
     *******************************************************/

    DEBUG_trace(args);

    if (!EvEVENT_SET(args)) {
	DEBUG_trace(args);
	XSRETURN_NO;
    }

    if (event_pending(&args->ev, EV_TIMEOUT|EV_READ|EV_WRITE, NULL) 
	&& event_del(&args->ev) == 0) {
	EvEVENT_SET_off(args);

	/* when called from inside a callback, we defer this
	 * SvREFCNT_dec. do_callback will do it for us. This
	 * is to prevent that the event is already DESTROYed
	 * from inside the handler which cannot be detected
	 * in do_callback. */
	if (!RUNNING_callback(args))
	    /* We are not using ST(0) here but instead the loop-back
	     * object stored inside the event because this is what is
	     * decremented in do_callback and incremented in event_add */
	    SvREFCNT_dec((SV*)args->ev.ev_evcallback.evcb_arg);

	DEBUG_trace(args);
    }

    DEBUG_trace(args);
    XSRETURN_NO;
}
#line 1172 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__base_except_handler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_except_handler)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "args, func");
    {
	struct event_args *	args;
	SV *	func = ST(1)
;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::except_handler() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 706 "Lib.xs"
{
    if (!SvROK(func) && (SvTYPE(SvRV(func)) != SVt_PVCV))
	croak("Argument to event_register_except_handler must be code-reference");
    args->trapper = (CV*)SvRV(func);
    SvREFCNT_inc(args->trapper);
    XSRETURN(1);
}
#line 1204 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__base_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::callback() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 718 "Lib.xs"
{
    ST(0) = sv_2mortal(newRV_inc((SV*)args->func));
    XSRETURN(1);
}
#line 1231 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib__base_args); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_args)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "args, ...");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::args() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 727 "Lib.xs"
{
    register int i;

    if (items == 1) {
	/* arguments are merely queried */
	U32 gimme = GIMME_V;
	switch (gimme) {
	    case G_VOID:
		return;
	    case G_SCALAR:
		ST(0) = sv_2mortal(newSViv(args->num));
		XSRETURN(1);
	    case G_ARRAY:
		EXTEND(SP, args->num);
		for (i = 0; i < args->num; ++i)
		    ST(i) = args->args[i];
		XSRETURN(args->num);
	}
    }

    /* items > 1: arguments are replaced */

    for (i = 0; i < args->num; ++i)
	SvREFCNT_dec(args->args[i]);
    if (items - 1 > args->buckets) {
	args->buckets = items - 1;
	Renew(args->args, args->buckets, SV*);
    }
    args->num = items - 1;
    for (i = 0; i < args->num; ++i) {
	args->args[i] = ST(i+1);
	SvREFCNT_inc(args->args[i]);
    }
}	
#line 1288 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib__base_args_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_args_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::args_del() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 766 "Lib.xs"
{
    register int i;
    for (i = 0; i < args->num; ++i)
	SvREFCNT_dec(args->args[i]);
    args->num = 0;
}
#line 1317 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__base_set_priority); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_set_priority)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "args, prio");
    {
	struct event_args *	args;
	int	prio = (int)SvIV(ST(1))
;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::set_priority() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 778 "Lib.xs"
{
    args->priority = prio;
}
#line 1345 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__base_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__base_trace)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::base::trace() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 786 "Lib.xs"
{
    EvEVENT_TRACED_on(args);
    XSRETURN(1);
}
#line 1372 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__event_fh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__event_fh)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event::fh() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 797 "Lib.xs"
{
    DEBUG_trace(args);
    ST(0) = args->io;
    XSRETURN(1);
}
#line 1400 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib__event_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__event_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event::pending() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 807 "Lib.xs"
{
    struct timeval tv = { 0, 0 }, now;
    SV *sv;

    gettimeofday(&now, NULL);

    if (!event_pending(&args->ev, EV_READ|EV_WRITE|EV_TIMEOUT, &tv))
	XSRETURN_NO;

    if (tv.tv_sec == 0 && tv.tv_usec == 0)
	sv = newSVpvn("0 but true", 10);
    else 
	sv = newSVnv(fabs(delta_timeval(&now, &tv)));

    ST(0) = sv_2mortal(sv);
    XSRETURN(1);
}
#line 1440 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib__event_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__event_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::event::DESTROY() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 829 "Lib.xs"
{
    DEBUG_trace(args);
    DEBUG_warn("[DESTROY]   ev = 0x%p (%s)\n  (from %s)", args, args->type, SvPV_nolen(args->loc));

    /* We get to DESTROY a pending event:
     * This can happen when an event object was explictely 
     * reassigned to or when undef() was called on it.
     * We DO NOT delete and free it. Instead we issue a warning
     * disassociate this event from ST(0) and keep it pending */
    if (!IN_GLOBAL_CLEANUP && 
	EvEVENT_SET(args) && event_pending(&args->ev, EV_READ|EV_WRITE, NULL)) {
	if (ckWARN(WARN_MISC))
	    warn("Explicit undef() of or reassignment to pending event");
	refresh_event(args, HvNAME(SvSTASH(SvRV(ST(0)))));
	XSRETURN_EMPTY;
    }

    DEBUG_delete_event(aTHX_ ST(0));
    DEBUG_delete_allo(aTHX_ ST(0));

    free_args(args);
}
#line 1485 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__signal_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__signal_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::signal::pending() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 859 "Lib.xs"
{
    struct timeval tv = { 0, 0 }, now;
    SV *sv;

    DEBUG_trace(args);

    gettimeofday(&now, NULL);

    if (!signal_pending(&args->ev, &tv))
	XSRETURN_NO;

    if (tv.tv_sec == 0 && tv.tv_usec == 0)
	sv = newSVpvn("0 but true", 10);
    else 
	sv = newSVnv(fabs(delta_timeval(&now, &tv)));

    ST(0) = sv_2mortal(sv);
    XSRETURN(1);
}
#line 1527 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib__signal_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__signal_remove)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::signal::remove() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 883 "Lib.xs"
{

    /******************************************
     * !! OVERRIDING Event::Lib::base::remove !! *
     ******************************************/

    /* XXX This works for the test-suite but who knows.
     * XXX The culprit is that signal-events behave
     * XXX differently: They are per default persistent.
     * XXX Still, additional logic may be required here. */
    if (event_del(&args->ev) == 0) {
	EvEVENT_SET_off(args);
	XSRETURN_YES;
    }

    XSRETURN_NO;
}
#line 1567 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__signal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__signal_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::signal::DESTROY() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 905 "Lib.xs"
{

    DEBUG_warn("[DESTROY]   ev = 0x%p (%s)\n  (from %s)", args, args->type, SvPV_nolen(args->loc));
    DEBUG_trace(args);

    /* We get to DESTROY a pending event:
     * This can happen when an event object was explictely 
     * reassigned to or when undef() was called on it.
     * We DO NOT delete and free it. Instead we issue a warning
     * disassociate this event from ST(0) and keep it pending */
    if (!IN_GLOBAL_CLEANUP &&
	EvEVENT_SET(args) && signal_pending(&args->ev, NULL)) {
	if (ckWARN_d(WARN_MISC))
	    warn("Explicit undef() of or reassignment to pending event");
	refresh_event(args, HvNAME(SvSTASH(SvRV(ST(0)))));
	XSRETURN_EMPTY;
    }

    DEBUG_delete_event(aTHX_ ST(0));
    DEBUG_delete_allo(aTHX_ ST(0));

    free_args(args);
}
#line 1613 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__timer_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__timer_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::timer::pending() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 936 "Lib.xs"
{
    struct timeval tv = { 0, 0 }, now;
    SV *sv;

    gettimeofday(&now, NULL);

    if (!evtimer_pending(&args->ev, &tv))
	XSRETURN_NO;

    if (tv.tv_sec == 0 && tv.tv_usec == 0)
	sv = newSVpvn("0 but true", 10);
    else 
	sv = newSVnv(fabs(delta_timeval(&now, &tv)));

    ST(0) = sv_2mortal(sv);
    XSRETURN(1);
}
#line 1653 "Lib.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__Lib__timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__timer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "args");
    {
	struct event_args *	args;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
	    args = (struct event_args *)SvIV((SV*)SvRV( ST(0) ));
    else{
	    warn( "Event::Lib::timer::DESTROY() -- args is not a blessed SV reference" );
	    XSRETURN_UNDEF;
    }
;
#line 958 "Lib.xs"
{
    DEBUG_warn("[DESTROY]   ev = 0x%p (%s)\n  (from %s)", args, args->type, SvPV_nolen(args->loc));
    DEBUG_trace(args);

    /* We get to DESTROY a pending event:
     * This can happen when an event object was explictely 
     * reassigned to or when undef() was called on it.
     * We DO NOT delete and free it. Instead we issue a warning
     * disassociate this event from ST(0) and keep it pending */
    if (!IN_GLOBAL_CLEANUP &&
	EvEVENT_SET(args) && evtimer_pending(&args->ev, NULL)) {
	if (ckWARN(WARN_MISC))
	    warn("Explicit undef() of or reassignment to pending event");
	refresh_event(args, HvNAME(SvSTASH(SvRV(ST(0)))));
	XSRETURN_EMPTY;
    }

    DEBUG_delete_event(aTHX_ ST(0));
    DEBUG_delete_allo(aTHX_ ST(0));

    free_args(args);
}
#line 1698 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__Debug_get_pending_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__Debug_get_pending_events)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 986 "Lib.xs"
{
    DEBUG_get_pending_events(aTHX);
}
#line 1715 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__Debug_dump_pending_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__Debug_dump_pending_events)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 993 "Lib.xs"
{
    DEBUG_dump_pending_events(aTHX);
}
#line 1732 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__Debug_dump_allocated_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__Debug_dump_allocated_events)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1000 "Lib.xs"
{
    DEBUG_dump_allocated(aTHX);
}
#line 1749 "Lib.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Lib__Debug_dump_event_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Lib__Debug_dump_event_count)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1007 "Lib.xs"
{
    PerlIO_printf(PerlIO_stderr(), "%i: fh:%i signal:%i timer:%i\n", getpid(), 
				   EVENT_NEW_COUNT, SIGNAL_NEW_COUNT, TIMER_NEW_COUNT);
}
#line 1767 "Lib.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Event__Lib); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Event__Lib)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Event::Lib::constant", XS_Event__Lib_constant);
        newXS_deffile("Event::Lib::_default_callback", XS_Event__Lib__default_callback);
        (void)newXSproto_portable("Event::Lib::event_init", XS_Event__Lib_event_init, file, "");
        cv = newXS_deffile("Event::Lib::event_get_method", XS_Event__Lib_event_get_method);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Event::Lib::get_method", XS_Event__Lib_event_get_method);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Event::Lib::event_get_version", XS_Event__Lib_event_get_version);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Event::Lib::get_version", XS_Event__Lib_event_get_version);
        XSANY.any_i32 = 0;
        newXS_deffile("Event::Lib::event_log_level", XS_Event__Lib_event_log_level);
        newXS_deffile("Event::Lib::event_register_except_handler", XS_Event__Lib_event_register_except_handler);
        (void)newXSproto_portable("Event::Lib::event_priority_init", XS_Event__Lib_event_priority_init, file, "$");
        newXS_deffile("Event::Lib::event_new", XS_Event__Lib_event_new);
        newXS_deffile("Event::Lib::signal_new", XS_Event__Lib_signal_new);
        newXS_deffile("Event::Lib::timer_new", XS_Event__Lib_timer_new);
        newXS_deffile("Event::Lib::event_add", XS_Event__Lib_event_add);
        newXS_deffile("Event::Lib::event_free", XS_Event__Lib_event_free);
        (void)newXSproto_portable("Event::Lib::event_mainloop", XS_Event__Lib_event_mainloop, file, "");
        (void)newXSproto_portable("Event::Lib::event_one_loop", XS_Event__Lib_event_one_loop, file, ";$");
        (void)newXSproto_portable("Event::Lib::event_one_nbloop", XS_Event__Lib_event_one_nbloop, file, "");
        newXS_deffile("Event::Lib::base::remove", XS_Event__Lib__base_remove);
        newXS_deffile("Event::Lib::base::except_handler", XS_Event__Lib__base_except_handler);
        newXS_deffile("Event::Lib::base::callback", XS_Event__Lib__base_callback);
        newXS_deffile("Event::Lib::base::args", XS_Event__Lib__base_args);
        newXS_deffile("Event::Lib::base::args_del", XS_Event__Lib__base_args_del);
        newXS_deffile("Event::Lib::base::set_priority", XS_Event__Lib__base_set_priority);
        newXS_deffile("Event::Lib::base::trace", XS_Event__Lib__base_trace);
        newXS_deffile("Event::Lib::event::fh", XS_Event__Lib__event_fh);
        newXS_deffile("Event::Lib::event::pending", XS_Event__Lib__event_pending);
        newXS_deffile("Event::Lib::event::DESTROY", XS_Event__Lib__event_DESTROY);
        newXS_deffile("Event::Lib::signal::pending", XS_Event__Lib__signal_pending);
        newXS_deffile("Event::Lib::signal::remove", XS_Event__Lib__signal_remove);
        newXS_deffile("Event::Lib::signal::DESTROY", XS_Event__Lib__signal_DESTROY);
        newXS_deffile("Event::Lib::timer::pending", XS_Event__Lib__timer_pending);
        newXS_deffile("Event::Lib::timer::DESTROY", XS_Event__Lib__timer_DESTROY);
        newXS_deffile("Event::Lib::Debug::get_pending_events", XS_Event__Lib__Debug_get_pending_events);
        newXS_deffile("Event::Lib::Debug::dump_pending_events", XS_Event__Lib__Debug_dump_pending_events);
        newXS_deffile("Event::Lib::Debug::dump_allocated_events", XS_Event__Lib__Debug_dump_allocated_events);
        newXS_deffile("Event::Lib::Debug::dump_event_count", XS_Event__Lib__Debug_dump_event_count);

    /* Initialisation Section */

#line 273 "Lib.xs"
{
    if (getenv("EVENT_LOG_LEVEL"))
	LOG_LEVEL = atoi(getenv("EVENT_LOG_LEVEL"));
#ifdef HAVE_LOG_CALLBACKS
    event_set_log_callback(log_cb);
#endif
    event_do_init();
    DEFAULT_EXCEPTION_HANDLER = newXS(NULL, XS_Event__Lib__default_callback, __FILE__);
}

#line 1855 "Lib.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

